import java.awt.event.*;
import java.awt.datatransfer.*;
import java.awt.*;
import java.util.*;
import java.io.*;

class GetSetView extends OOView implements ClipboardOwner,
                                           KeyListener {

    public Clipboard clipboard = Toolkit.getDefaultToolkit().
                                            getSystemClipboard();
    private String result = new String();
    private boolean edited = false;
    private GetSetView() {
        super("GetSet");
        this.initialize();
    }

    public void lostOwnership(Clipboard clipboard, Transferable contents){}

    public static void main( String alf[] ) {

        GetSetView aGetSetView = new GetSetView();

        aGetSetView.show();
    }

    private void initialize() {

        TextField tf = new TextField();
        tf.setSize(180,20);
        tf.setLocation(10,50);
        this.addWidget("classField", tf);

        tf = new TextField();
        tf.setSize(180,20);
        tf.setLocation(10,75);
        tf.addActionListener(this);
        this.addWidget("nameField", tf);

        TextArea ta = new TextArea();
        ta.setSize(340,100);
        ta.setLocation(10,132);
        ta.addKeyListener(this);
        this.addWidget("comment", ta);

        this.initMenu();
        this.initChoices();
        this.initLabels();

        this.setSize(360,240);
        this.setLocation(200,200);

        this.clear();

    }
    public void initLabels(){

        Label aLabel = new Label("Variable");
        aLabel.setSize(80,30);
        aLabel.setLocation(305,46);
        this.add(aLabel);

        aLabel = new Label("Getter");
        aLabel.setSize(80,30);
        aLabel.setLocation(305,71);
        this.add(aLabel);

        aLabel = new Label("Setter");
        aLabel.setSize(80,30);
        aLabel.setLocation(305,96);
        this.add(aLabel);

        aLabel = new Label();
        aLabel.setSize(80,30);
        aLabel.setLocation(10,100);
        this.addWidget("editedLabel",aLabel);

    }
    public void clear(){
        ((TextField) this.getWidget("nameField")).setText("");
        ((TextArea) this.getWidget("comment")).setText("");
        ((TextField) this.getWidget("classField")).setText("");
        ((TextField) this.getWidget("classField")).requestFocus();
        this.clipboard.setContents(new StringSelection(""),this);
        this.result = "";
        ((Label) this.getWidget("editedLabel")).setText("Clear");

    }

    public void initMenu(){
        MenuBar aMenuBar = new MenuBar();

        Menu aMenu = new Menu("File");
        MenuItem aMenuItem = new MenuItem("Exit");
        aMenuItem.addActionListener(this);
        aMenuItem.setActionCommand("Exit");
        aMenu.add(aMenuItem);
        aMenuBar.add(aMenu);

        aMenu = new Menu("GetSet");
        aMenuItem = new MenuItem("Clear");
        aMenuItem.addActionListener(this);
        aMenuItem.setActionCommand("Clear");
        aMenu.add(aMenuItem);
        aMenuBar.add(aMenu);

        this.setMenuBar(aMenuBar);
    }
    public void initChoices(){
        Choice c = new Choice();
        c.addItem("private");
        c.addItem("public");
        c.addItem("protected");
        c.addItem("");
        c.setSize(100,30);
        c.setLocation(200,45);
        this.addWidget("varChoice", c);

        c = new Choice();
        c.addItem("private");
        c.addItem("public");
        c.addItem("protected");
        c.addItem("");
        c.setSize(100,30);
        c.setLocation(200,70);
        this.addWidget("getChoice", c);

        c = new Choice();
        c.addItem("private");
        c.addItem("public");
        c.addItem("protected");
        c.addItem("");
        c.setSize(100,30);
        c.setLocation(200,95);
        this.addWidget("setChoice", c);

    }


    public String processComment(){

        String commentText = ((TextArea) this.getWidget("comment")).getText();
        LineNumberReader theStream =
                new LineNumberReader(new StringReader(commentText));
        String comment = "\n\t/**";
        String nextLine = null;
            try{
                nextLine = theStream.readLine();
                while( !(nextLine == null) ){
                    comment = comment + "\n\t *  " + nextLine ;
                    nextLine = theStream.readLine();
                }
            }
            catch(IOException ioe){
                System.out.println("ioexception in processcomment");
            }
        comment = comment + "\n\t */";
        return comment;
    }



    public void makeTextAndAppend(){



String comment = this.processComment();

((TextArea) this.getWidget("comment")).getText();

String varVis = ((Choice) this.getWidget("varChoice")).getSelectedItem();
String getVis = ((Choice) this.getWidget("getChoice")).getSelectedItem();
String setVis = ((Choice) this.getWidget("setChoice")).getSelectedItem();
String className = ((TextField) this.getWidget("classField")).getText();
String varName = ((TextField) this.getWidget("nameField")).getText();
String setterVar = new String();
String setterPrefix = new String();
String theBigString = new String();

String firstLetter = String.valueOf(
                Character.toUpperCase(className.charAt(0)));


    if( firstLetter.equals("A") ||
        firstLetter.equals("E") ||
        firstLetter.equals("I") ||
        firstLetter.equals("O") ||
        firstLetter.equals("U") ||
        firstLetter.equals("H")
    ){
        setterPrefix = "an";
    }
    else{
        setterPrefix = "a" ;
    }

setterVar = setterPrefix + firstLetter + className.substring(1);



theBigString =


    comment + "\n\t" +
    varVis + " " + className + " " + varName + "_;" +
    "\n\t" + getVis + " " + className + " " + varName + "() { return " + varName + "_; }" +
    "\n\t" + setVis + " void " + varName + "( " + className + " " + setterVar + " ) { " + varName + "_ = " + setterVar + "; }" + "\n"     ;

this.result += theBigString;
      this.clipboard.setContents(new StringSelection(this.result),this);

System.out.println(this.result);

((TextField) this.getWidget("nameField")).setText("");
((TextField) this.getWidget("classField")).setText("");
((TextArea) this.getWidget("comment")).setText("");
((TextField) this.getWidget("classField")).requestFocus();


    }
    public void actionPerformed(ActionEvent e){
        String s = e.getActionCommand();

        if( s == "Exit" ){
            this.exit();
            return;
        }
        if( s == "Clear" ){
            this.clear();
            return;
        }
    }
    public void keyPressed(KeyEvent ke){
      //  System.out.println("keyPressed");
        }
    public void keyReleased(KeyEvent ke){
     //   System.out.println("keyReleased");
        }
    public void keyTyped(KeyEvent ke){
      //  System.out.println("keyTyped");
        if( ke.getKeyChar() == '\u001b' ){
            ((Label) this.getWidget("editedLabel")).setText("Edited");
            this.makeTextAndAppend();
        }
    }
    public void windowClosing(WindowEvent we){
        this.exit();
    }
    private void exit(){
        System.out.println("closing GetSet");
        try{ Thread.sleep(500); }
        catch(InterruptedException ie){}
        this.dispose();
        System.exit(0);
    }

}
